<? require "../lib.php"?>
<? aheader("Luca Development Diary - from 0.45 to 0.5"); ?>

<p>
2006/10/14
 
<p>
I am a bit lazy to implement new things. When we want to avoid some task,
we tend to get busy on other things. In my case, these other things are
small improvements in already working Luca modules, as well the autotest
script.

<p>
The script test is ready for prime time now. It still needs to be itself tested :)
so in fact it is not really ready :)) but at least the idea is laid down and it
documents itself, it is not taking space in my brain RAM anymore. I plan to
test the script and deliver a usable version along with 0.5 release.
 
<p>
The test script still has a lot of room for improvement - for example, it only
tests JSON calls, not "lite" (pure HTML) methods, let alone the Kid template
processing. Another thing is to estimate the source code coverage of the tests; 
I need to find some tool to do that in Python.

<p>
2006/10/22
 
<p>
Small change of plans. I am growing seek of my PHP accounting system, and more seek
about not being able to test Luca with real data. To fix that, I decided to change
some priorities.

<p>
First, all crucial components of the accounting system (journals, batches, reports
and balance closing) will be developed in the 0.5 release timeframe. So, once 0.5 
is out, anyone can (in theory) use it for real bookkeeping. 
 
<p>
These components will not be fully developed in 0.5; in particular the journal entry
page will be *very* crude and unfriendly. All the components will be steadily polished
in next releases; 0.6 should deliver a friendly journal entry, 0.7 should have more
beautiful reports and so on.

<p>
0.5 will also see the integration of my former project "ctbclient", a mobile client
where you can do journal entries. It runs on Maemo and Series 60 smartphones. It is
going to be renamed to "lucamobile" or something. Since "ctbclient" was developed
having in mind that the backend would be changed from CTB to Luca someday, I expect
that it will have almost no modifications from the current version. The only major
change will be in "server_database" module since it needs to be adapted against
Luca SQL data dictionary.
 
<p>
Once Luca 0.5 is out, it essentially osboletes CTB, so I can kill the CTB/Ctbclient
project leaving Luca in place. CTB will still be downloadable as a relic source code.

<p>
2006/11/05
 
<p>
Following the trend of avoiding the implementation and, mainly, the *debugging* of new and critical
features, I have completed all basic components of Luca: batches (untested), journals (untested),
all reports and balance closing. A database conversion from CTB to Luca was also created. The
CTBClient mobile client was renamed to LucaMobile and integrated into Luca's CVS.

<p>
This rush of new components into Luca aims to make up a completely functional/usable version
in 0.5 release. At the very least I will be able to migrate my accounting from CTB to Luca.
This will speed the development since I will have a stake on the system and I every improvement
will be immediately profitable. (Sometimes it is difficult to develop UI stuff without an 
use case.)
 
<p>
I was very happy to see that the balance calculation routine worked almost flawlessly from
the first test, apart from some obvious syntax errors that were easy to spot and fix. 
It is worthwhile to remember that this routine serves several reports: balance, income
statement and cash flow statement. The other reports (ledger and journal) are more boring, 
they are just exhaustive lists of journals selected directly from table.

<p>
The cash flow statement brought a small challenge. I included an "aggregation" option in this
report, so the cash flow can be reported in progressively more generic views. It is not worthwhile
to see that you spend $5 in juice (specific account), but may be important to see if you spent $50000 in
food (being food an aggregate account of all food-related specific accounts).

<p>
The problem was: my chart of accounts has 5 levels, but some accounts "jump" some levels, because
some accounts just don't need five levels of aggregation. For exemple, my chart uses only three
levels for equity accounts: the top-level Equity account, one sub-aggregation account and the
specific accounts that receive journals. Both CTB and Luca allow "level jumping" to avoid 
an unnecessary number of intermediate aggregations. However, both systems demand that top-level
accounts are level 1, and accounts that can receive journals must be the maximum level (i.e. level 5
in my chart).

<p>If I request a cash flow statement with 1 level of aggregation, that means that the report
will show the level 4 aggregation accounts, but e.g. Equity has no level 4 accounts, so it
stayed out of the report. Of course this report will be wrong since some money source or sink
had been left out.

<p>After a brief moment of desperation (I thought that I would have to forbid level jumping
and therefore I would have to change my chart of accounts), I recalled that CTB report handled
this problem gracefully. So I mimicked the solution in Luca cash flow.

<p>The solution was to use a graph-coloring algorithm, 1) searching non-aggregate accounts that
have not contributed yet to the report; 2) finding the account's parent that is *at least* as
aggregate as the report demands; 3) given this parent, mark ("paint") all its children, grandchildren etc. as 
included in the report.

<p>This algorithm guarantees that 1) all money movements will be properly reflecteed in the 
report, no matter the chosen aggregation level; 2) level jumpings are trivially dealt with,
since if the *exact* aggregate parent is not found, we fall back to a *more* aggregate parent;
3) there is no risk that an exact-level aggregate and a more aggregate ancestor are both 
included in the report, since the recursive painting of the more aggregate ancestor will
hide the exact-level child again.

<p>
Another major, but very easy, change in the architecture was the adoption of 100-scaled values
in journals. The previous version used to have a Decimal(16,2) column in the table. Since
all internal handling must be exact, I always multiplied by 100 before any other operation.
I was growing sick of the abundant upscale and downscale of values, so I decided to standartize
in 100-scaled values throughout the whole system. The only moment the values are "downscaled"
is when they are shown in a Web page (and even there they are not truly divided by 100).

<p>
One problem that is still unsolved is the localization of date and number formats. I am 
not sure if I should use the system default locale settings or include those settings
in some table. Could be in general settings (cmos), users or organizations. The idea of having
a different locale for each organization or for each user is tempting (thinking about
a system being used by people from different countries). Of course putting a system-wide
single configuration is easier for me.

<p>
Now, the biggest issues before 0.5 release is the deep test of batch and journal entry
pages, as well the balance closing (this one is easy). The mobile client must also be
tested before 0.5 since I employ it for my own accounting (after all, it is working
nicely; the adaptation to the new database model is confined to a single module and
should not difficult to debug).

<p>I haven't tested the automated tests yet. I am not sure if I will do this in 0.5
or 0.6 timeframe. 

<p>2006/11/07

<p>
I have discovery a very furtive bug yesterday, again something related with Unicode/string
conversion. After the big problems I had to patch out in TurboGears, once in a while the
system still showed errors related to UTF-8 decoding to Unicode. It didn't happen for a
time until yesterday.

<p>I happened to note that the error was triggered by filling a form field to the maximum
size *and* putting a non-ASCII character in the *last* position. The row was saved to
database but the Unicode error was raised when it tried to fetch it.
By looking directly at SQL I could see that the string had only one non-ASCII character
at the last position, which was clearly wrong since any non-ASCII char is encoded with
at least 2 bytes in UTF-8.

<p>So the problem is: an Unicode string of length X may take (much) more than X bytes
when stored. So there is no point in limiting a UTF-8 string size in SQL level. 

<p>This is exactly the kind of thing that I expected an object-oriented abstraction of 
SQL to handle gracefully, but SQLObject does *not*. An UnicodeCol with length of 20
will create a VARCHAR(20) in MySQL. At the very least it should create a VARCHAR(120),
which may waste space but would guarantee that every Unicode string would fit in the
underlying UTF-8 column.

<p>Funny was to hear an echo of the past when I stumbled on this bug. About 12 years ago,
a frield called Alexandre Krammel said that a database with varchars should not be 
given maximum lengths; such lengths should only be enforced at application level. It
makes very easy to increase a column's maximum length in the future. 

<p>That is the solution I adopted: removed all length limits from SQLObject columns,
and left only the (Unicode) string length limits silently enforced in every 
controller.strip() method.

<p>SQL was *not* the only place I found impedance mismatch between Unicode and UTF-8.
The TurboGears form field validators also have problems with this. For example,

<pre>
validators.UnicodeString(max=20, encoding="utf-8")
</pre>

The limit of 20 characters is enforced *before* conversion to Unicode, which was not
what I intended the validator to do... Not only it will cut strings shorted than
expected, it can trigger the same Unicode exception that I first had in SQL level.
Again, the solution is to remove all limits in validators, and enforce only in
controller.strip() that only handles pure Unicode strings.

<p>A final problem is that SQL columns that are indexed (keys, foreign keys and 
indexes created for optimization purposes) must have a specified maximum size.
So, some columns of Luca will still need to be varchar(size) instead of text.
Account codes and user nicknames are two examples. 

<p>There are two solutions: either rule out non-ASCII characters from these columns
(account codes and e-mails should not have accented letters in general), or 
create SQL-level columns large enough to swallow the Unicode strings (e.g. 
accounts may be 20 characters wide, so the column must be varchar(120)).

<p>I feel the six-fold SQL column is better, since it will readily accomodate
non-ASCII characters. Feels too much anachronistic to filter out non-ASCII 
characters. This solution will waste some disk space since indexed columns
will occupy 6 times more space, but disk space is cheap :)

<p>The only exceptions were: permission name, that is guaranteed to be 
pure ASCII (the user can not change this table from the Web), so it can
keep the original, small size. And the user e-mail, that would be 1560 characters
long (255*6), but this overflows the MySQL limit for key size. So I kept
the 255 byte limit, and added a check in the controller to see if the
UTF-8 size of e-mail will not exceed 255 (completely unlikely since form
limit is 100 characters and e-mails have no accented letters).

<? footer("/luca", "en"); ?>

