<? require "../lib.php"?>
<? aheader("Luca Development Diary - from 0.6 to 0.65"); ?>

<p>2006/11/27

<p>A lot less philosophy and a lot more improvement and bugfixing in this version.
This is easily seen by the changelog: several small things that showed to be useful
now that I am using Luca for my own accounting.

<p>First of all, I found two security-related bugs, one of them that could leak data.
Another quite annoying bug was the inability of validators to attribute a default value
when the value from JSON or form was completely invalid (e.g. an "aaaa" string for an Int).
Fortunately the solution was simple: just supply if_invalid attributes for each validator,
it works like a "default" value. One thing that tests still do not catch since they do not
encode the calls in JSON or HTML.

<p>Now the improvements (at least I hope them to be considered as so :) I have disabled
the special ENTER key handling in data entry forms. For an old-timer it feels nice to use
ENTER to go to the next key, but I feel that people are utterly used to TAB nowaways. Another
thing that I did was to remove Javascript code that changed focused input background color:
this is better and easier handled in CSS (with :focus pseudo-classes).

<p>I have added a couple "short-circuit" links, and I am going to add more of them as I
have new ideas. Several pages are related to others, for example I spot an error in a ledger
report and would like to go immediately to journal entries page to fix it. So now the batch
ID is a link to that page. The same feature is present in journal report.

<p>I have removed some features from "lite" (Javascript-disabled) forms. After a brief
moment considering removing those alternative forms for good, I decided to keep them
since they demand the controllers to distinguish very well between controlling and viewing
concepts. So, at the very least, the system "owes" something to the presence of that
alternative pages. 

<p>But those pages will not have "fancy" features; they are for emergency situations where
someone needs to use the system but does not have an updated browser in the machine; they
are not for everyday use. And they should not bring big maintenance costs for me :) They
should be the simplest possible.

<p>Another "major" change in all pages was to replace most buttons by links. The first
inspiration for that was the feeling that lite pages felt more pretty than AJAX ones,
simply because lite pages employ links to call for the edit/add form. It is a trend
that can be seen in all Google Web applications - nobody feels the need to make pages
that feel like Windows 95 UIs... I have kept the buttons inside the add/edit form
since (again) other major Web apps do it too, and in that case the buttons make clear
to the user that he has to submit the operation.

<p>Another trend that I began to implement in Luca, initially in a single page and in
a primitive way, is the avoiding of page reloads. The chosen page to be the guinea pig
is charts_accounts (accounts of the chart). This page was chosen because a chart of
accounts tends to be large, and it makes the page reload quite slow. It made quite
uncomfortable to maintain my chart.

<p>Removing and updating data in place was quite easy to do, it was just a matter
of assigning an unique HTML ID for each row and column. The problem was to handle
*new* data, because a) it would cost a lot to implement client-side sorting to
insrt the new row in the expected place; b) in a long table, the new row would not
be apparent to the user; c) in a complex page like charts_accounts, several 
appearance details like indentation and bold depend on the data, which again costs
a lot to reproduce at client side.

<p>The solution by now is to include all new rows at the beginning of the table,
so the user can easily see the list of last-inserted rows. I think is the best
feedback for someone that is typing a lot of data; it is better than inserting
the row in the "right" position but the user can't see it, so he does not know
if it were correctly inserted or not. No visual effect like indentation or bold
is added to new rows; if the user wants to see the latest chart in the traditional
form, he needs to reload it. 

<p>Another thing that we still don't do is to update the page when other user
makes some change in the data. It would be nice but very difficult to make it
work right; and may be pointless since in general there will not be two persons
working on the very same data at the same time. Of course, we may implement this
in the future as a proof of concept for a changed-often table like journal entries.

<p>I think that this primitive approach already helps a lot in everyday use, so
the 0.7 release will see this approach applied to all controllers. I am sure
there is an infinite list of improvements that should be added to AJAX forms. 
To stay in the accounts of the chart page, I would like to see collapsible 
account hierarchies (and the same feature applied to balance and income reports).
But our TODO list is still too long of more basic things, so this kind of 
improvement belongs to the future.

<? footer("/", "en"); ?>

