<? require "../lib.php"?>
<? aheader("Luca Development Diary - from 0.7 to 0.8"); ?>

<p>
2007/03/05 - Transaction ID

<p>
In some point of the future, Luca will be fed with journal entries from other
systems, like accounts payable, accounts receivable etc. There must be some 
king of 'hook' between journal entries and those external systems.

<p>
Right now there are none of such systems, but I have already envisoned the 
'hook', based on experience with previous applications. The journal table
got a new column, called 'transaction', that is basically an optional 
foreign key that has no meaning for the journal itself, but can be 
referred by other systems.

<p>Another possible approach would be to avoid direct links between journal
entries and external transactions, and linking *batches* to transactions,
since each system will write entries in its own batch only. But that approach
would complicate things for that external systems in the future, because they
would have to keep track of individual entries by themselves - or create a batch
for every tiny transaction which would lead to an explosive number of batches,
something that is ugly and we don't want.

<p>Journal entries with non-NULL transaction IDs may not be updated or
cancelled via the 'normal' journal entries page, since the entries were
generated by some external event, and can only be changed if that event
is edited in any way.

<p>
The transaction ID generator will probably some new column added to 'cmos'
table, since such IDs will need to be unique across different systems that
do not talk with each other. Another idea is to have a completely new 
table called 'transactions', which primary key (ID) will be unique and
therefore can be copied to the related journals (this is my favorite
approach since it is very flexible to future extensions).

<p>
Journal entries inserted via Luca itself have Transaction ID = NULL, which
means they are not seekable by transaction and are not related to any external system.
I thought about putting the batch ID in that column, or using a new
non-null transaction ID for each entry, but I saw that it would be of
no use and no help.

<p>
2007/03/06 - Cancellation of journal entries

<p>
A 'perfect' accounting system must be very, very secure and safe. Everything that users do,
must be logged (for security) and, to the greatest possible extent, reversible (for safety). 
Users do commit a lot of errors in the course of day-to-day work, so any system they work on
must be the friendliest possible in order to allow undoing mistakes. I used to maintain a
small financial system that had only one irreversible operation, and it was enough to generate
more than half of support calls.

<p>
I even thought about using a ZODB database for Luca since it is a snapshot database, that is,
it can be rolled back to any previous state. This approach has severe performance drawbacks if
the objects are changed often, but for an accounting system that tipically only adds
new journals that are hardly ever changed, it would be perfect.

<p>
Most Luca tables are protected against data changes that would cause problems, but the
journal entries table was largely unprotected. If someone deletes an entry, it does not
break anything but will make the reports to print wrong values. Also, if a journal entry
is removed, this is irreversible, and the user doesn't even have a chance to query
the data it had just removed in order to reinsert it. 

<p>
So I decided to change the paradigm for journal entries. They can not be deleted anymore;
they can only be cancelled. Once cancelled they will not appear in reports anymore, but
will be kept in the batch for future reference, and of course thay can be un-cancelled
easily.

<p>This approach has two drawbacks: 'testing' entries can never be removed, they will
'pollute' the batch forever. This is the price of safety. (And the administrator can
always remove the entries via SQL if they really must be wiped out.) The other
drawback is that Luca log is currently a bit too terse; if an entry is cancelled, the
log will point that the entry was changed - but it does not tell *which* data changed,
not even for the cancellation operation. 

<p>I plan to improve the logging in a more general way, so any data change in any
table will be logged in detail.

<p>Last but not least, external systems will be able to remove journal entries
that they had automatically generated. Since those entries were automatically
generated from data stored somewhere else, and often they are re-generated 
many many times during report checks and error fixing, there is no benefit in 
keeping the old data around. 

<? footer("/", "en"); ?>


