import cherrypy

import turbogears
from turbogears import controllers, redirect, flash
from turbogears import identity

from luca.model import hub, notfound, integrity, sqlerror, modelerror, ModelError, gconn, denied

from model  import permission
import mylib
import random
import model

class simple_table(controllers.Controller):

# MODEL- AND LANGUAGE-SPECIFIC CODE & MESSAGES ######################################

#    validators = {"id": validators.Int(if_invalid=0),
#      		"user_name": validators.UnicodeString(if_invalid=u""),
# 	         "email_address": validators.UnicodeString(if_invalid=u""),
# 	         "password": validators.UnicodeString(if_invalid=u""),
# 		 "display_name": validators.UnicodeString(if_invalid=u"")}
#
    def setup(self):
#   	    self.emptyrow_read = {"id": 0, "user_name": "", "email_address": "", "password": "", "display_name": ""}
#	    self.empty_intermediate = self.emptyrow_read
#   	    self.emptyrow_write = self.emptyrow_read
#
#	    self.formatters = {}
#
# 	    self.msg_unexpected = "ERROR: unexpected SQL error. Contact the system administrator"
#	    self.msg_notfound = "User not found, probably it has just been deleted"
#	    self.show_msg_ajax = False
#           self.msg_added = "User has been added"
#           self.msg_updated = "User has been updated"
#           self.msg_removed = "User has been removed sucessfully"
#           self.msg_validation = "Name, nickname and e-mail address must not be empty"
#           self.msg_validation_crash = "Unexpected validation error: notify system administrator!"
#           self.msg_integrity = "Integrity error: "
#           self.msg_cannotremove = "User can not be removed"
#           self.msg_unique = "check if both user name and e-mail are unique"
#           self.msg_legend_update = "System users: editing user '%s'"
#           self.msg_legend_add = "System users: adding new user"
#    	    self.table = xuser

# 	    data for automated tests
#
#	    * Non-obvious data (columns not contained here will be random generated)
#	    * Note: the third element will be added and removed short aftewards.
#		    You must provide at least three elements, since the last one is always removed.
#	    self.sample_data = [{"chart": 1}, {"chart": 2}, {"chart": 3}]
#
#	    * Samples of invalid data. Permissive columns must not be included here.
#	    self.invalid_data = [("name", ""), ("chart", 0)]
#
#	    * Columns that are alternate keys for the ror. For integrity test (try to add duplicates)
#	    self.unique_cols = ["name"]
#
#	    * Foreign keys, as (controller, foreign key ID) pairs. For integrity test (try to remove
#		 						rows that other rows depend upon)
# 	    self.foreign_keys = [("charts", 1), ("charts", 2)]

	raise StandardError("You should have overriden this!") #pragma: no cover

    def intermediate_validate(self, intermediate):
	    '''Second-level validation, that sends error message back instead of crashing'''
	    return "" #pragma: no cover

    def perm_org(self, interm):
	''' Returns an org ID for logging purposes.
	    Most tables have no relationship with organizations, so this parent class
	    offers a default 'null' method (that may be overridden)'''
	return 0 #pragma: no cover

    def row_name(self, d_row):
	''' Returns a name for the given row dictionary, suitable for logging.
	    Row must be passed as a dictionary of columns
	'''
        raise StandardError("You should have overriden this!") #pragma: no cover

    def data_legend(self, intermediate):
	''' Returns a legend for the given data'''
        raise StandardError("You should have overriden this!") #pragma: no cover

    def test__new_row_fixup(self, base_row): #pragma: no cover
	# Allows the controller to fixup an automatically generated new row for testing purposes.
	pass

    def test__verify_excuse(self, colname, orig, fetched, orig_row, fetched_row): #pragma: no cover
	# returns True if the pointed difference between data inserted and data retrieved
	# can be excused (e.g. users controller never returns the password back for security reasons)
	return 0

    def test__nonunique_update_fixup(self, row): #pragma: no cover
	# Allows the controller to fixup an automatically generated nonunique row for testing purposes
	pass

    def test__should_verify_update(self, row): #pragma: no cover
	# returns whether the just inserted/updated row should be tested
	# (should return 0 in cases where the returned data would be too different to be handled by
	# test__verify_excuse()
	return 1

    def test__generate_invalid_rows(self, base_good_row, for_insertion): #pragma: no cover
	# Generates a matrix of bad rows based on a good row and controller-provided bad columns.
	# Useful for testing both insertions and updates '''
	bad_rows = []
	bad_samples = {}
	# rearranges bad samples as a dictionary of lists
	for bad in self.invalid_data:
		if bad[0] not in bad_samples:
			bad_samples[bad[0]] = []
		bad_samples[bad[0]].append(bad[1])
	# generates all possible combinations of single-error rows
	for bad_col in bad_samples:
		bad_col_possibilities = bad_samples[bad_col]
		for bad_data in bad_col_possibilities:
			bad_rows.append(base_good_row.copy())
			bad_rows[-1][bad_col] = bad_data
	# generates some multiple error combinations
	if len(bad_samples) > 1:
		for bad_col in bad_samples:
			bad_col_possibilities = bad_samples[bad_col]
			for bad_data in bad_col_possibilities:
				bad_rows.append(base_good_row.copy())
				bad_rows[-1][bad_col] = bad_data
				another_bad_col = random.choice(bad_samples.keys())
				another_bad_data = random.choice(bad_samples[another_bad_col])
				bad_rows[-1][another_bad_col] = another_bad_data
	# adds compound erros (i.e. that arise by interaction of two or more columns' values)
	if hasattr(self, "invalid_compound"):
		for bad_compound in self.invalid_compound:
			bad_rows.append(base_good_row.copy())
			for bad_col in bad_compound.keys():
				bad_data = bad_compound[bad_col]
				bad_rows[-1][bad_col] = bad_data
	if for_insertion and hasattr(self, "invalid_compound_new"):
		for bad_compound in self.invalid_compound_new:
			bad_rows.append(base_good_row.copy())
			for bad_col in bad_compound.keys():
				bad_data = bad_compound[bad_col]
				bad_rows[-1][bad_col] = bad_data
	if (not for_insertion) and hasattr(self, "invalid_compound_update"):
		for bad_compound in self.invalid_compound_update:
			bad_rows.append(base_good_row.copy())
			for bad_col in bad_compound.keys():
				bad_data = bad_compound[bad_col]
				bad_rows[-1][bad_col] = bad_data

	return bad_rows

    def test__generate_nonunique_rows_add(self, base_row): #pragma: no cover
	# Generate rows different from base_row except for the unique columns
	bad_rows = []
	for unique_col in self.unique_cols:
		bad_rows.append(base_row.copy())
		self.test__fill_row_with_random_data(bad_rows[-1], {}, self.sample_data[0].keys())
		bad_rows[-1][unique_col] = base_row[unique_col]
	return bad_rows

    def test__generate_nonunique_rows_update(self, target_row, another_row): #pragma: no cover
	# Generate updated rows that have integrity problems (unique cols with values from another row)
	bad_rows = []
	for unique_col in self.unique_cols:
		bad_rows.append(self.test__generate_modified_row(target_row))
		bad_rows[-1][unique_col] = another_row[unique_col]
	return bad_rows

    def test__fill_row_with_random_data(self, row, sample, donttouch): #pragma: no cover
	# Fills generic row with random data, except columns found in sample
	for col in row.keys():
		if col in sample:
			row[col] = sample[col]
		elif col not in donttouch:
			# should be either integer or string/unicode
			if type(row[col]) is int:
				row[col] = random.randint(1,10000)
			else:
				row[col] = mylib.random_string(300)

    def test__generate_new_row(self, sample_row): #pragma: no cover
	row = self.empty_intermediate.copy()
	self.test__new_row_fixup(row)
	self.test__fill_row_with_random_data(row, sample_row, {})
	return row

    def test__generate_modified_row(self, current_row): #pragma: no cover
	# Modifies row data for update testing
	modified_row = current_row.copy()
	self.test__fill_row_with_random_data(modified_row, {}, {})
	# restores columns in sample with original data, since random data may be invalid
	for col in self.sample_data[0].keys():
		try:
			modified_row[col] = current_row[col]
		except KeyError:
			raise
	modified_row["id"] = current_row["id"]
	return modified_row

    def test__gen_data(self): #pragma: no cover
 	# Generates a complete data pool for testing purposes
	rows = []
	invalid_rows = []
	nonunique_rows = []
	update_rows = []
	invalid_update_rows = []
	nonunique_update_rows = []

	for sample_row in self.sample_data:
		rows.append(self.test__generate_new_row(sample_row))
		invalid_rows.extend(self.test__generate_invalid_rows(rows[-1], True))
		nonunique_rows.extend(self.test__generate_nonunique_rows_add(rows[-1]))
		update_rows.append(self.test__generate_modified_row(rows[-1]))
		invalid_update_rows.append(self.test__generate_invalid_rows(rows[-1], False))

	for row in rows:
		row["id"] = 0
	for row in invalid_rows:
		row["id"] = 0
	for row in nonunique_rows:
		row["id"] = 0
	for x in range(0, len(rows)):
		nonunique_update_rows.append(self.test__generate_nonunique_rows_update(rows[x], rows[(x+1) % len(rows)]))
		for c in nonunique_update_rows[-1]:
			self.test__nonunique_update_fixup(c)

	return (rows, invalid_rows, nonunique_rows, update_rows, invalid_update_rows, nonunique_update_rows)

    def test__get_bump(self, row, bumptable, bumpcol, idname): #pragma: no cover
	if type(idname) is int:
		id = idname
	else:
		id = row[idname]
	try:
		r = getattr(getattr(model, bumptable).get(id), bumpcol)
	except sqlerror:
		# does not exist
		r = -1
	return r

    def test__bump_pre(self, t, row): #pragma: no cover
	self._pre_bump = []
	for bump in self.test_bump:
		self._pre_bump.append(self.test__get_bump(row, *bump))

    def test__bump(self, t, row, remove=0): #pragma: no cover
	x = 0
	for bump in self.test_bump:
		a = self._pre_bump[x]
		b = self.test__get_bump(row, *bump)
		print "bump %d %d" % (a,b)
		if remove and getattr(model, bump[0]) == self.table and a >= 0 and b == -1:
			continue
		if a >= b:
			t.fail("Wrong version bump: %d %d %s" % (a, b,  unicode(bump)))

    def test__add(self, t, row): #pragma: no cover
	arow = row.copy()
	arow["id"] = -1
	if self.test__update(t, arow):
		if "id" in t.cargo:
			row["id"] = t.cargo["id"]
		return True
	return False

    def test__add_lite(self, t, row): #pragma: no cover
	arow = row.copy()
	arow["id"] = -1
	if self.test__update_lite(t, arow):
		if "id" in t.cargo:
			row["id"] = t.cargo["id"]
		return True
	return False

    def test__index_lite(self, t): #pragma: no cover
	t.cargo = t.tu.call(self.lite)
	if not t.cargo["err"]:
		return True
	return False

    def test__index(self, t): #pragma: no cover
	t.cargo = t.tu.call(self.index)
	if not t.cargo["err"]:
		return True
	return False

    def test__indexHTML(self, t): #pragma: no cover
	# FIXME: does not respect identity
	req = t.tu.DummyRequest()
	req.scheme = "http"
	t.tu.create_request("/"+t.C.__class__.__name__+"/index")
	print cherrypy.response.body
	raise Exception("blex")
	if not t.cargo["err"]:
		return True
	return False

    def test__fetch_lite(self, t, id): #pragma: no cover
	t.cargo = t.tu.call(self.lite_edit, id)
	if not t.cargo["err"]:
		return True
	return False

    def test__fetch(self, t, id): #pragma: no cover
	t.cargo = t.tu.call(self.fetch, id)
	if not t.cargo["err"]:
		return True
	return False

    def test__update(self, t, row): #pragma: no cover
	t.cargo = res = t.tu.call(self.update, **row)
	if not res["err"]:
		return True
	return False

    def test__update_lite(self, t, row): #pragma: no cover
	t.cargo = res = t.tu.call(self.lite_commit, **row)
	if not res["err"]:
		return True
	return False

    def test__remove(self, t, id): #pragma: no cover
	t.cargo = res = t.tu.call(self.remove, id)
	return not res["err"]

    def test__remove_lite(self, t, id): #pragma: no cover
	t.cargo = res = t.tu.call(self.lite_remove, id)
	return not res["err"]

    def test__run(self, t): #pragma: no cover
	t.C = self
	t.cargo = None

	t.rows, t.invalid_rows, t.nonunique_rows, t.update_rows, t.invalid_update_rows, t.nonunique_update_rows = self.test__gen_data()

	self.test__load_index(t)
	self.test__fetch_empty_row(t)
	self.test__insert_rows(t, t.rows)

	if 'cant_insert' not in t.flags():
		self.test__insert_invalid_rows(t)

	if 'cant_fetch_by_id' not in t.flags():
		self.test__fetch_nonexistent(t)

	if hasattr(self, 'remove'):
		self.test__remove_nonexistent(t)
		if 'cant_remove_id_1' in t.flags():
			self.test__remove_id_1(t)

	self.test__rows_loop(t); # main tests

	if 'cant_update_id_1' in t.flags():
		self.test__invalid_update_id1(t)

	if hasattr(self, 'remove'):
		self.test__valid_remove(t)

	if hasattr(self, 'remove'):
		self.test__valid_remove_lite(t)

	self.test__reload_index(t)
	self.test__try_remove_deps(t)

	if hasattr(self, 'test__run_extra'):
		self.test__run_extra(t)


    def test__rows_loop(self, t): #pragma: no cover
	t.logmask = 0
	for x in range(0, len(t.rows)):
		t.xxx = x
		row = t.rows[x]
		invalid_updates = t.invalid_update_rows[x]
		nonunique_updates = t.nonunique_update_rows[x]

		if 'cant_fetch_by_id' not in t.flags():
			if random.randint(0,4) == 0:
				# get data just after add, sometimes :)
				self.test__fetch_empty_row(t)
			self.test__row_fetch(t, row) # t.cargo will contain row data
			self.test__row_fetch_chk(t, row) # will use t.cargo
			self.test__row_fetch_chk_form(t, row)

			self.test__row_fetch_lite(t, row) # t.cargo will contain row data
			self.test__row_fetch_chk(t, row) # will use t.cargo
			self.test__row_fetch_chk_form(t, row)
			if not self.test__should_verify_update(row):
				continue
			self.test__try_nonunique_update(t, row, nonunique_updates)

		self.test__row_invalid_update(t, row, invalid_updates)
		self.test__row_valid_update(t, row)
		if hasattr(self, 'test__rows_loop_extra'):
			self.test__rows_loop_extra(t, row)


    def test__row_fetch(self, t, row): #pragma: no cover
	t.logmask = 0
	res = t.permission_explode("fetch", self.test__fetch, t.DONE, row["id"])
	if not res:
		t.fail("Failed fetch %d" % row["id"])

    def test__row_fetch_lite(self, t, row): #pragma: no cover
	t.logmask = 0
	res = t.permission_explode("fetch lite ", self.test__fetch_lite, t.DONE, row["id"])
	if not res:
		t.fail("Failed fetch %d" % row["id"])

    def test__row_fetch_chk(self, t, row): #pragma: no cover
	for col in row:
		val = row[col]
		if col not in t.cargo:
			t.fail("Column %s not found (fetch after add)" % col)
		if type(t.cargo[col]) is str:
			t.cargo[col] = unicode(t.cargo[col])
		if type(t.cargo[col]) is int:
			t.cargo[col] = long(t.cargo[col])
		if type(val) is str:
			val = unicode(val)
		if type(val) is int:
			val = long(val)
		if type(t.cargo[col]) is not type(val):
			t.fail("Col '%s' type '%s' unexpected ret '%s' (fetch after add)" % (col, type(val), type(t.cargo[col])))

		if type(val) is unicode:
			l = len(t.cargo[col])
			if l >= 14 and l < len(val):
				# string stripping took place in controller (acceptable)
				val = val[:l]

		if val != t.cargo[col] and not self.test__verify_excuse(col, val, t.cargo[col], row, t.cargo):
			t.fail(u"Col '%s' value '%s' unexpected ret '%s' (fetch after add)" % (col, val.strip(), t.cargo[col]))


    def test__row_fetch_chk_form(self, t, row): #pragma: no cover
	if "Legend" not in t.cargo or "Heading" not in t.cargo:
		t.fail("Legend or Heading not present in fetch (fetch after add)")


    def test__try_nonunique_update(self, t, row, nonunique_updates): #pragma: no cover
	t.logmask = t.FAIL + t.DENIED
	for nonunique in nonunique_updates:
		nonunique["id"] = row["id"]
		if t.permission_explode("try nonunique", self.test__update, t.FAIL, nonunique):
			t.fail("Should have failed invalid update "+str(nonunique))
		if hasattr(self, "lite_commit"):
			if t.permission_granted("try nonunique", self.test__update_lite, t.FAIL, nonunique):
				t.fail("Should have failed invalid update (lite) "+str(nonunique))

    def test__row_valid_update(self, t, row): #pragma: no cover
	t.logmask = 0
	self.test__bump_pre(t, row)
	if not t.permission_explode("valid update", self.test__update, t.DONE, row):
		t.fail("Failed update "+str(row))
	self.test__bump(t, row)
	if hasattr(self, 'lite_commit'):
		self.test__bump_pre(t, row)
		if not t.permission_explode("valid update lite", self.test__update_lite, t.DONE, row):
			t.fail("Failed update "+str(row))
		self.test__bump(t, row)

    def test__row_invalid_update(self, t, row, invalid_updates): #pragma: no cover
	for invalid in invalid_updates:
		t.logmask = t.FAIL + t.DENIED
		invalid["id"] = row["id"]
		if t.permission_explode("Try invalid update", self.test__update, t.FAIL, invalid):
			t.fail("Should have failed invalid update "+str(invalid))
		if hasattr(self, "lite_commit"):
			t.logmask = t.FAIL + t.DENIED
			expected = t.FAIL
			if 'lite_update_calls_all_rows' in t.flags():
				# can happen to return a DENIED log after a failure (all_rows update)
				t.logmask = t.FAIL
				expected = t.FAIL + t.DENIED
			if t.permission_explode("Try invalid update lite", self.test__update_lite, expected, invalid):
				t.fail("Should have failed invalid update "+str(invalid))

    def test__invalid_update_id1(self, t): #pragma: no cover
	t.logmask = t.FAIL
	res = t.permission_explode("fetch id 1", self.test__fetch, t.DONE, 1)
	invalid_1 = t.cargo.copy()
	t.logmask = t.FAIL + t.DENIED
	if t.permission_explode("try invalid update id 1", self.test__update, t.FAIL, invalid_1):
		t.fail("Should have failed invalid update id 1 "+str(invalid_1))
	if hasattr(self, "lite_commit"):
		t.logmask = t.FAIL + t.DENIED
		if t.permission_explode("try invalid update lite id 1", self.test__update_lite, t.FAIL, invalid_1):
			t.fail("Should have failed invalid update lite id 1 "+str(invalid_1))

    def test__valid_remove(self, t): #pragma: no cover
	t.logmask = 0
	self.test__bump_pre(t, t.rows[-1])
	if not t.permission_explode("valid remove", self.test__remove, t.DONE, t.rows[-1]["id"]):
		t.fail("Failed to remove %d" % rows[-1]["id"])
	self.test__bump(t, t.rows[-1], 1)

    def test__valid_remove_lite(self, t): #pragma: no cover
	t.logmask = 0
	self.test__bump_pre(t, t.rows[-2])
	if not t.permission_granted("valid remove (lite)", self.test__remove_lite, t.DONE, t.rows[-2]["id"]):
		t.fail("Failed to remove %d" % t.rows[-2]["id"])
	self.test__bump(t, t.rows[-2], 1)


    def test__fetch_nonexistent(self, t): #pragma: no cover
	t.logmask = t.FAIL + t.DENIED
	if t.permission_explode("fetch nonexistent", self.test__fetch, t.DONE, 999):
		t.fail("Should have failed fetch 999")

    def test__remove_nonexistent(self, t): #pragma: no cover
	t.logmask = t.FAIL + t.DENIED
	if t.permission_explode("remove nonexistent", self.test__remove, t.FAIL, 999):
		t.fail("Should have failed remove 999")

    def test__remove_id_1(self, t): #pragma: no cover
	t.logmask = 0
	if t.permission_explode("remove id 1 ", self.test__remove, t.FAIL, 1):
		t.fail("Should have failed remove ID 1")


    def test__insert_invalid_rows(self, t): #pragma: no cover
	t.logmask = t.FAIL + t.DENIED
	for row in t.invalid_rows:
		if t.permission_explode("add invalid row", self.test__add, t.FAIL, row):
			t.fail("Should have failed insertion "+str(row))
	if self.unique_cols:
		for row in t.rows:
			if t.permission_explode("duplicate unique col", self.test__add, t.FAIL, row):
				t.fail("Should have failed duplicate insertion "+str(row))
	for row in t.nonunique_rows:
		if t.permission_explode("nonunique row", self.test__add, t.FAIL, row):
			t.fail("Should have failed non-unique insertion "+str(row))


    def test__insert_rows(self, t, rows): #pragma: no cover
	t.logmask = 0
	if 'noorg_insert_allowed' in t.flags():
		# We cannot really demand for permission for that organization if it does not exist yet.
		t.forgive_org_permission_hole = 1
	x = 1
	for row in rows:
		self.test__insert_row(t, row, x)
		x += 1
	t.forgive_org_permission_hole = 0


    def test__insert_row(self, t, row, x):  #pragma: no cover
	if 'cant_insert' not in t.flags():
		t.logmask = 0
		if not t.permission_explode("insert", self.test__add, t.DONE, row):
			t.fail("Failed row insertion "+str(row))
	elif 'cant_update_by_id' not in t.flags():
		t.logmask = t.FAIL + t.DENIED
		if t.permission_explode("insert", self.test__add, t.DONE, row):
			t.fail("Should have failed row insertion "+str(row))
		if t.permission_explode("insert lite", self.test__add_lite, t.DONE, row):
			t.fail("Should have failed row insertion "+str(row))
		# fake new ID since we can't really include rows
		row["id"] = x


    def test__fetch_empty_row_core(self, t): #pragma: no cover
	# a new empty row is never denied, because organization is still unknown
	t.logmask = 0
	t.forgive_org_permission_hole = 1
	res = t.permission_explode("fetch empty", self.test__fetch, t.DONE, 0)
	res2 = t.permission_explode("fetch empty", self.test__fetch_lite, t.DONE, 0)
	t.forgive_org_permission_hole = 0
	return (res, res2)


    def test__fetch_empty_row(self, t): #pragma: no cover
	t.logmask = 0
	res = None

	# TEST: fetching a new, empty row
	if 'cant_insert' not in t.flags():
		res, res2 = self.test__fetch_empty_row_core(t)
		if not res:
			t.fail("Failed 0-fetch ")
		if not res2:
			t.fail("Failed lite 0-fetch")
	elif 'cant_fetch_0' not in t.flags():
		t.logmask = t.FAIL + t.DENIED
		res = t.permission_explode("fetch empty", self.test__fetch, t.DONE, 0)
		if res:
			t.fail("Should have failed 0-fetch ")
		if hasattr(self, "lite_edit"):
			res = t.permission_explode("fetch empty lite", self.test__fetch_lite, t.DONE, 0)
			if res:
				t.fail("Should have failed 0-fetch ")
		t.logmask = 0

	if res:
		emptyone = self.empty_intermediate.copy()
		self.test__new_row_fixup(emptyone)
		for col in emptyone:
			val = emptyone[col]
			if col not in t.cargo:
				t.fail("Column %s not found" % col)
			if type(t.cargo[col]) is not type(val):
				t.fail("Column % with unexpected type" % col)
		if "Legend" not in t.cargo or "Heading" not in t.cargo:
			t.fail("Legend or Heading not present in fetch")


    def test__load_index(self, t): #pragma: no cover
	t.logmask = t.DONE

	if "index_is_fetch" in t.flags():  # req. index will trigger a fetch and hence will be logged
		t.logmask = 0

	if 'noorg_index_allowed' in t.flags():
		# a person can at least see the org list even if he has no permission to edit some
		t.forgive_org_permission_hole = 1
		if 'anyone_index_allowed' in t.flags():
			# every user can change its own password
			t.logmask = t.DONE
			t.forgive_permission_hole = 1
			pass

	res = t.permission_explode("", self.test__index, t.DONE)
	if not res:
		t.fail("Failed")
	if hasattr(self, 'lite'):
		res = t.permission_explode("", self.test__index_lite, t.DONE)
		if not res:
			t.fail("Failed")
	t.forgive_org_permission_hole = 0

	# t.permission_explode("", self.test__indexHTML, t.DONE)

    def test__reload_index(self, t):	 #pragma: no cover
	t.logmask = t.DONE

	if "index_is_fetch" in t.flags():  # req. index will trigger a fetch and hence will be logged
		t.logmask = 0

	if 'noorg_index_allowed' in t.flags():
		# a person can at least see the org list even if he has no permission to edit some
		t.forgive_org_permission_hole = 1
		if 'anyone_index_allowed' in t.flags():
			# every user can change its own password
			t.logmask = t.DONE
			t.forgive_permission_hole = 1
			pass
	res = t.permission_explode("AGAIN ", self.test__index, t.DONE)
	if not res:
		t.fail("Failed")
	if hasattr(self, "lite"):
		res = t.permission_explode("AGAIN ", self.test__index_lite, t.DONE)
		if not res:
			t.fail("Failed")
	t.forgive_org_permission_hole = 0


    def test__try_remove_deps(self, t): #pragma: no cover
	t.logmask = 0
	for foreign_key in self.foreign_keys:
		foreign = getattr(t.r00t, foreign_key[0])
		t.cargo = None
		t.logmask = 0
		if hasattr(foreign, 'remove'):
			# t.logmask = t.FAIL + t.DENIED
			if t.permission_explode("try to remove dependency", foreign.test__remove, t.FAIL, foreign_key[1]):
				t.fail("Failed to catch integrity error %s %d" % foreign_key)
			t.logmask = 0


# BOILERPLATE CODE (INIT & ERRORS) ################################################

    def __init__(self, log):
        super(simple_table, self).__init__()
	self.streamlined_add = False
	self._indexflash = None    # flash message to be shown in the next index page
	self._indexflash_err = 0
	self._editflash = None    # flash message to be shown in the next index page
	self._editflash_err = 0
	self.formatters = {}

	self.test_flags = ()
	self.vips = []

	self.setup()
    	self.log = log

    def flash_at_index(self, msg, err):
	self._indexflash = msg
	self._indexflash_err = err

    def flash_at_edit(self, msg, err):
	self._editflash = msg
	self._editflash_err = err

    def flash(self, form_data, msg, err):
	flash(msg)
	if err:
		form_data["tg_flash_class"] = "errmsg"
	else:
		form_data["tg_flash_class"] = "infomsg"

    def sqlerr(self, exception):  #pragma: no cover
	    print exception
	    self.log.error("%s SQL error %s %s", self.__class__.__name__, exception.__class__.__name__, str(exception.args))
	    return self.msg_unexpected

    def sqlnotfound(self, exception):
	    self.log.error("%s SQL warning %s", self.__class__.__name__, str(exception.args))
	    return self.msg_notfound

    def sqlintegrity(self, exception, extramsg=""): #pragma: no cover
	    self.log.error("%s SQL warning %s", self.__class__.__name__, str(exception.args))
	    return self.msg_integrity+extramsg

### DATA CONVERSION ROUTINES ######################################################################

    def db_to_row(self, db_row):
	''' Converts a model row to a dictionary row '''
	row = self.emptyrow_read.copy()
	for i in row.keys():
		row[i] = getattr(db_row, i)
	return row

    # There is no row_to_db since SQLObject can accept dictionaries directly

    def row_to_intermediate(self, row):
	''' Converts a row to intermediate representation '''
	intermediate = self.empty_intermediate.copy()
	for i in intermediate.keys():
		if i in row:
			intermediate[i] = row[i]
	self.row_to_intermediate_ext(row, intermediate)
	return intermediate

    def intermediate_to_row(self, intermediate):
	# TODO: optimization: have two different versions of emptyrow_write, one for new, other for update
	''' Converts intermediate representation to a SQL-apropriate row '''
	row = self.emptyrow_write.copy()
	for i in row.keys():
		if i in intermediate:
			row[i] = intermediate[i]
	self.intermediate_to_row_ext(intermediate, row)
	return row

    def intermediate_to_form(self, intermediate):
	''' Converts the intermediate representation to form fields. '''
	form_data = intermediate.copy()
	form_data["Legend"] = self.data_legend(intermediate)
	if intermediate["id"] > 0:
	    form_data["Heading"] = self.msg_legend_update % form_data["Legend"]
	else:
	    form_data["Heading"] = self.msg_legend_add
	self.intermediate_to_form_ext(intermediate, form_data)
	return form_data

    def form_to_intermediate(self, form_data):
	''' Converts form data to the intermediate format '''
	intermediate = self.empty_intermediate.copy()
	for i in intermediate.keys():
		if i in form_data:
			intermediate[i] = form_data[i]
	self.form_to_intermediate_ext(form_data, intermediate)
	return intermediate

    def row_to_intermediate_ext(self, row, intermediate):
	'''Post-processing method that can be overriden by subclasses'''
	pass  #pragma: no cover

    def intermediate_to_row_ext(self, intermediate, row):
	'''Post-processing method that can be overriden by subclasses'''
	pass  #pragma: no cover

    def intermediate_to_form_ext(self, intermediate, form_data):
	'''Post-processing method that can be overriden by subclasses'''
	pass  #pragma: no cover

    def form_to_intermediate_ext(self, form_data, intermediate):
	'''Post-processing method that can be overriden by subclasses'''
	pass  #pragma: no cover

    def auxiliary_form_data(self, form_data):
	'''Overridable function that is called for all forms, with row data or not'''
	pass  #pragma: no cover

    def new_row_recoil(self, row_data):
	''' Gives an opportunity to manipulate data before a new row insertion screen
		is displayed. By default, all data from the last row is copied to the
		new one. It is a good idea to clean at least one required row in order
		to avoid accidental double rows (not a problem if one of the colums is
		a unique key) '''
	pass  #pragma: no cover

    def table_version(self, row_data):
	''' Called when we need to know the 'version' of the data we are manipulating.
	    Version is a monotonic counter used to detect if there is someone else
  	    changing the same data, so we need e.g. to force a page update in the client.
	    Controllers that care about concurrent access should override this method
	    meaningfully.

	    Overridden methods must TOLERATE problems in row_data e.g. some data missing,
	    should it be result of e.g. a failed data fetch, and return -1 if it cannot
	    safely determine the data's version'''
	return 0  #pragma: no cover

    def format(self, name, data):
	return self.base_format(name, data)

    def base_format(self, name, data):
	'''Formats a data token to be shown as in a HTML data column.
	   Normally such formatting would belong to the Kid template, but AJAX
           screens may want to update rows in place without reloading, so they need
	   a way to call for formatted data. This function is driven by the
	   self.formatters dictionary.'''

	s = data
	if name in self.formatters:
		s = self.formatters[name](s)

	return s

    def format_row(self, data_row):
	'''Does the formatting job for a whole data 'row' at once.'''
	sd = {}

	for name in data_row.keys():
		data = data_row[name]
		sd[name] = self.base_format(name, data)

	if "_extra_" in self.formatters:
		self.formatters["_extra_"](sd)

	return sd

    def data_diff(self, old, new):
	''' Creates a human-readable message about which data was changed '''
	s = ""
	for k in old.keys():
		if old[k] != new[k] and k != "password":
			s += u'| %s: "%s" -> "%s" ' % (k.upper(), unicode(old[k]), unicode(new[k]))
	return s

#########################################################################

    def all_rows(self, *filters, **filters2):
	rows = []
	err = ""
	grant = None

	try:
		grant = permission(self, "read", 0, permission.MASK_DONE, "all_rows")
		rows = self.table.select(*filters, **filters2)
		grant.done()
	except denied, e:
		err = e.args[0]
	except modelerror, e:
		err = e.args[0]
	except sqlerror, e:  #pragma: no cover
		err = self.sqlerr(e)
	# Harmless if grant.done() has already been called
	if grant:
		grant.fail(err)

        return (rows, err)


    def base_index(self, *filters, **filters2):
	rows, err = self.all_rows(*filters, **filters2)
	form_data = dict(rows=rows, err=err)
	self.auxiliary_form_data(form_data)
	# more complex pages will override base_index and so the version gathering way-of
	try:
		form_data["table_version"] = self.table_version({})
	except sqlerror:  #pragma: no cover
		form_data["table_version"] = -1

	if err:
		self.flash(form_data, err, True)
	elif self._indexflash:
		self.flash(form_data, self._indexflash, self._indexflash_err)
	self._indexflash = None

	return form_data

    def trigger_remove_pre(self, row):
	''' Overridable trigger called when a row is about to be deleted.
		Return a non-empty string if the row should not be deleted.
	'''
	return ""

    def trigger_remove_post(self, row):
	'''Overridable trigger called with a row has just been deleted.
		SQL errors will be "ignored" (not shown to the user), so the
		function does not need to handle them
	'''
	pass

    def base_remove(self, id):
	err = ""
	msg = ""
	grant = None
	interm = {}

	try:
		db_row = self.table.get(id)
		row = self.db_to_row(db_row)
		interm = self.row_to_intermediate(row)

		grant = permission(self, "write.remove", self.perm_org(interm), 0, id)

		row_name = self.row_name(row)

		err = self.trigger_remove_pre(row)
		if err:
			raise ModelError(err)

		self.table.delete(id)
		self.trigger_remove_post(row)

		grant.done(row_name)
		gconn.cache.clear()
	except denied, e:
		err = e.args[0]
	except notfound, e:
		err = self.sqlnotfound(e)
	except integrity, e: #pragma: no cover
		if model._testing_:
			raise Exception("Unhandled integrity error in remove")
		# should never happen since all controllers must check their foreign keys explicitelyi
		err = self.sqlintegrity(e, self.msg_cannotremove)
	except modelerror, e:
		err = e.args[0]
	except sqlerror, e:  #pragma: no cover
		err = self.sqlerr(e)

	if grant:
		grant.fail(err)

	if not err:
		msg = self.msg_removed
		if msg.find("%d") >= 0:
			msg = msg % id

	return {"err": err, "msg": msg, "table_version": self.table_version(interm)}


    def base_lite_remove(self, id):
	    result = self.base_remove(id)
	    if result["err"]:
		self.flash_at_index(result["err"], err=1)
	    else:
		self.flash_at_index(result["msg"], err=0)
	    if model._testing_:
		return result
	    raise redirect("lite") #pragma: no cover

    def base_fetch(self, id, mothers = {}):
	err = ""
	grant = None

	row = self.emptyrow_read.copy()
	intermediate = self.empty_intermediate.copy()
	intermediate.update(mothers)

	if id <= 0:
		# new record
		x = model.session()
		try:
			last_new_row_data = x[self.__class__.__name__+"last_new_row_data"]
		except KeyError:
			last_new_row_data = None

		if last_new_row_data:
			# copy new row data from the last new one
			row = last_new_row_data
			intermediate = self.row_to_intermediate(row)

		# fill with data that is known in advance (e.g. organization ID in a journal entry)
		intermediate.update(mothers)
		intermediate["id"] = 0
	else:
		# fetch existing record
		try:
			db_row = self.table.get(id)
			row = self.db_to_row(db_row)
			intermediate = self.row_to_intermediate(row)
		except notfound, e:
			err = self.sqlnotfound(e)
		except modelerror, e:
			err = e.args[0]
		except sqlerror, e:  #pragma: no cover
		        err = self.sqlerr(e)

	if not err:
		try:
			grant = permission(self, "read", self.perm_org(intermediate), 0, id)
			grant.done(self.row_name(row))
		except denied, e:
			# not granted: do not leak out any data
			intermediate = self.empty_intermediate.copy()
			err = e.args[0]

       	form_data = self.intermediate_to_form(intermediate)
	form_data["err"] = err
	form_data["table_version"] = self.table_version(intermediate)
	return form_data

    def base_lite_edit(self, id):
	form_data = self.base_fetch(id)

        if form_data["err"]:
	  	# abort form display
		self.flash_at_index(form_data["err"], err=1)
		self._editflash = None
		if model._testing_:
			return form_data
		raise redirect("lite") #pragma: no cover

	if self._editflash:
		self.flash(form_data, self._editflash, self._editflash_err)
		self._editflash = None

	self.auxiliary_form_data(form_data)
	return form_data

    def trigger_update_pre(self, row, id, new, form_data):
	''' Overridable trigger called when a row is about to be updated/inserted.
		Return a non-empty string if the row should not be updated.
	'''
	return "" #pragma: no cover

    def trigger_update_post(self, row, id, new, form_data):
	'''Overridable trigger called with a row has just been updated/added.
		SQL errors will be caught, so the function does not need to handle them.
	'''
	pass #pragma: no cover

    def base_update(self, form_data):
	intermediate = self.form_to_intermediate(form_data)
	id = intermediate["id"]
	is_new = id <= 0
	msg = ""
	grant = None

	try:
		needs_rollback = False

		err = self.intermediate_validate(intermediate)
		if err:
			raise ModelError(err)

		row = self.intermediate_to_row(intermediate)

		grant = permission(self, is_new and "write.add" or "write.edit", self.perm_org(intermediate), 0, self.row_name(row))

		#####################################

		hub.commit()
		needs_rollback = True

		err = self.trigger_update_pre(row, id, is_new, form_data)
		if err: raise ModelError(err)

		del row["id"]
		if is_new:
			dbrow = self.table(**row)
			id = dbrow.id
			descr = str(id)
		else:
			dbrow = self.table.get(id)
			old_data = self.row_to_intermediate(self.db_to_row(dbrow))
			dbrow.set(**row)
			descr = self.data_diff(old_data, intermediate)

		self.trigger_update_post(row, id, is_new, form_data)

		hub.commit()
		needs_rollback = False
		#####################################

		grant.done(descr)
		gconn.cache.clear()

		if is_new:
			last_new_row_data = row.copy()
			last_new_row_data["id"] = 0
			self.new_row_recoil(last_new_row_data)

			x = model.session()
			x[self.__class__.__name__+"last_new_row_data"] = last_new_row_data

	except denied, e:
		if needs_rollback:
			hub.rollback()
		err = e.args[0]
	except notfound, e:
		if needs_rollback:
			hub.rollback()
		err = self.sqlnotfound(e)
	except integrity, e: #pragma: no cover
		# should never happen since all controllers must check uniqueness first
		if model._testing_:
			raise Exception("Unhandled integrity error in remove")
		if needs_rollback:
			hub.rollback()
		err = self.sqlintegrity(e, self.msg_unique)
	except modelerror, e:
		if needs_rollback:
			hub.rollback()
		err = e.args[0]
	except sqlerror, e:  #pragma: no cover
		if needs_rollback:
			hub.rollback()
		err = self.sqlerr(e)

	if grant is not None:
		grant.fail(err)

	if not err:
		if is_new:
			msg = self.msg_added
		else:
			msg = self.msg_updated
		if msg.find("%d") >= 0:
			msg = msg % id

	# returns the just-inserted row to the client, maybe he is interested :)
	final_row = {}
	formatted_row = {}
	table_version = -1
	if not err:
		try:
			final_row = self.row_to_intermediate(self.db_to_row(self.table.get(id)))
			formatted_row = self.format_row(final_row)
			table_version = self.table_version(final_row)
		except sqlerror, e:  #pragma: no cover
			pass

	form_data = {"err": err, "id": id, "new": is_new, "msg": msg, \
			"row": final_row, "row_formatted": formatted_row,
			"table_version": table_version }

	return form_data

    def base_lite_commit(self, form_data):
	is_streamlined = self.streamlined_add and form_data["id"] <= 0
	upd = self.base_update(form_data)
	if not upd["err"]:
		if is_streamlined:
			self.flash_at_edit(upd["msg"], err=0)
			if model._testing_:
				return upd
			raise redirect(turbogears.url("lite_edit", id=0)) #pragma: no cover
		self.flash_at_index(upd["msg"], err=0)
		if model._testing_:
			return upd
		raise redirect("lite") #pragma: no cover

	# send back all received data + the error message
	form_data = self.intermediate_to_form(self.form_to_intermediate(form_data))
	form_data.update(upd)
	self.auxiliary_form_data(form_data)
	return form_data

