/************************** GENERIC FUNCTIONS ***********************/

var fetch_remote_error_bad = "Server has sent an invalid response! Please contact system administrator!!";

var ajax_pending = false;
var previous_focus = null;  // focus highlighting (eye candy)
var fields = [];
// var fieldtags = [];
// var fieldtypes = [];
var highlight_fields = {"text": 1, "textarea": 1, "password": 1, "select": 1, "option": 1};
var dirty_page = false;
var streamlined_add = false;
var _is_streamlined;
var first_visible_field = 1;

// some functions test for <function name>_extend() or <name>_override(),
// which allows for some tables to extend or override event handlers
// without having to duplicate code

function is_defined(ot) {
	return ! (ot == null || ot == undefined);
}

function field_getvalue(i)
{
	var ret;
/*
	if (fieldtags[x] == "select") {
		var j = fields[x].selectedIndex;
		if (j >= 0) {
			ret = fields[x].options[j].value;
		} else {
			ret = "-1";
		}
	} else { */
		ret = fields[i].value; /*
	} */
	return ret;
}

function field_setvalue(i, value)
{
/*
	if (fieldtags[x] == "select") {
		var j = fields[x].selectedIndex;
		if (j >= 0) {
			ret = fields[x].options[j].value;
		} else {
			ret = "-1";
		}
	} else { */
		fields[i].value = value; /*
	} */
}

function ajax_setup()
{
	for (var x = 0; x < controls.length; ++x) {
		field = document.f[controls[x]];
		fields.push(field);
		// fieldtags.push(field.tagName ? field.tagName.toLowerCase() : "foo");
		// fieldtypes.push(field.type ? field.type.toLowerCase() : "foo");
		if (x >= first_visible_field) {
			// connect(field, "onkeydown", handleEnter);
			if (window.ajax_field_changed) {
				connect(field, "onblur", ajax_field_changed);
			}
		}
	}
	/*
	connect(document.f.bcancel, "onClick", ajax_cancel);
	connect(document.f.bsubmit, "onClick", ajax_commit);
	if (document.f.bremove) {
		connect(document.f.bremove, "onClick", ajax_remove);
	}

	connect(document.f.bsubmit, "onkeydown", handleEnter);
	connect(document.f.bcancel, "onkeydown", handleEnter);
	if (document.f.bremove) {
		connect(document.f.bremove, "onkeydown", handleEnter);
	}

	if (getElement("addrowbutton")) {
		connect("addrowbutton", "onclick", ajax_new);
	}
	*/

	// connect(document.f, "onsubmit", ajax_submit);

	// connect(document.f, "onkeyup", highlight);
	// connect(document.f, "onclick", highlight);


	if (window.ajax_setup_extend) {
		ajax_setup_extend();
	}
}

function ajax_submit(event) {
	callLater(0.01, ajax_commit);
	return false;
}

function ajax_hide()
{
	setElementClass("formdiv", "hidden");
	if (getElement("addrow")) {
		setElementClass("addrow", "shown");
	}
}

function ajax_unhide()
{
	if (hasElementClass("formdiv", "hidden")) {
		ajax_form_errmsg(" ");
		ajax_form_infomsg(" ");
		setElementClass("formdiv", "shown");
		if (getElement("addrow")) {
			setElementClass("addrow", "hidden");
		}
		// ajax_form_legend("Wait...");
	}
	ajax_throbber_end();
	// EPX: remove
	// setElementClass(fields[first_visible_field], "focus");
	// for (var x = first_visible_field+1; x < controls.length; ++x) {
		// setElementClass(fields[x], "");
	// }
	previous_focus = fields[first_visible_field];
	previous_focus.focus();
	window.scroll(0,0);
}

function ajax_throbber()
{
	setElementClass("waiting", "shown");
	setElementClass("waitingpad", "hidden");
}

function ajax_throbber_end()
{
	setElementClass("waiting", "hidden");
	setElementClass("waitingpad", "shown");
}

function ajax_form_errmsg(err)
{
	swapDOM("errmsg", DIV({"id": "errmsg"}, err));
	swapDOM("infomsg", DIV({"id": "infomsg"}, " "));
}

function ajax_form_infomsg(msg)
{
	swapDOM("infomsg", DIV({"id": "infomsg"}, msg));
	swapDOM("errmsg", DIV({"id": "errmsg"}, " "));
}

function ajax_form_legend(le)
{
	swapDOM("legend", LEGEND({"id": "legend"}, le));
}

function ajax_error()
{
	ajax_pending = false;
	ajax_throbber_end();
	alert(comm_error);
}

function ajax_error_hide()
{
	ajax_error();
	ajax_hide();
}

function ajax_refresh_page()
{
	dirty_page = false;
	if (window.ajax_refresh_page_override) {
		ajax_refresh_page_override();
	} else {
		// alert("Refreshing...");
		location.href = "./";
	}
}

function handle_version(version, commit) {
	// alert(commit+" server="+version+" local="+document.f.table_version.value);
	if (commit) {
		// row commit/remove: bump version up
		document.f.table_version.value = parseInt(document.f.table_version.value) + 1;
		if (version < 0) {
			// undefined version; do nothing
			return;
		}
		if (parseInt(document.f.table_version.value) < version) {
			// we've got company
			dirty_page = true;
		}
		document.f.table_version.value = version;
	} else {
		// row fetch
		if (version < 0) {
			// undefined version; do nothing
			return;
		}
		if (parseInt(document.f.table_version.value) < version) {
			// we've got company
			dirty_page = true;
		}
		document.f.table_version.value = version;
	}
}

function ajax_commit_gotdata(rres)
{
	ajax_pending = false;
	ajax_throbber_end();

	if (is_defined(rres.err) && rres.err != "") {
		ajax_form_errmsg(rres.err);
		return;
	}

	if (is_defined(rres.msg) && rres.msg != "") {
		ajax_form_infomsg(rres.msg);
	}

	handle_version(rres.table_version, 1);

	if (rres['new']) {
		var emptyrow = getElement("newrow_invisible").innerHTML;
		while (emptyrow.indexOf("FNEWID") >= 0) {
			emptyrow = emptyrow.replace("FNEWID", rres.id);
		}
		// Safari returns uppercase tags
		while (emptyrow.indexOf("<SPAN") >= 0) {
			emptyrow = emptyrow.replace("<SPAN", "<span");
		}

		for(var x = 0; x < inplace.length; ++x) {
			var idplace = '<span id="'+inplace[x]+'FNEW">';
			// escapeHTML guarantees that '<' and '>' will never appear in txt,
			// hence there is no possibility that data gets confused with '<span>' tag
			var txt = escapeHTML(""+rres.row_formatted[inplace[x]]);
			var idfill  = '<span id="'+inplace[x]+'F'+rres.id+'">'+txt;
			emptyrow = emptyrow.replace(idplace, idfill);
		}

		var tableDOM = getElement("tabledata").getElementsByTagName("table")[0];
		var rowDOM = tableDOM.insertRow(1);
		rowDOM.innerHTML = emptyrow;

		addElementClass(rowDOM, "ajaxupdated");
		setNodeAttribute(rowDOM, "id", "tr" + rres.id);

		if (is_defined(rres.id2)) {
			// oh no, yet another row
			emptyrow = getElement("newrow_invisible").innerHTML;
			while (emptyrow.indexOf("FNEWID") >= 0) {
				emptyrow = emptyrow.replace("FNEWID", rres.id2);
			}
			while (emptyrow.indexOf("<SPAN") >= 0) {
				emptyrow = emptyrow.replace("<SPAN", "<span");
			}

			for(var x = 0; x < inplace.length; ++x) {
				var idplace = '<span id="'+inplace[x]+'FNEW">';
				// escapeHTML guarantees that '<' and '>' will never appear in txt,
				// hence there is no possibility that data gets confused with '<span>' tag
				var txt = escapeHTML(""+rres.row2_formatted[inplace[x]]);
				var idfill  = '<span id="'+inplace[x]+'F'+rres.id2+'">'+txt;
				emptyrow = emptyrow.replace(idplace, idfill);
			}

			var tableDOM = getElement("tabledata").getElementsByTagName("table")[0];
			var rowDOM = tableDOM.insertRow(1);
			rowDOM.innerHTML = emptyrow;

			addElementClass(rowDOM, "ajaxupdated");
			setNodeAttribute(rowDOM, "id", "tr" + rres.id2);
		}

		if (_is_streamlined) {
			if (window.ajax_commit_pos) {
				ajax_commit_pos(rres); // called only if in-place-update has been done
			}
			ajax_new();
		} else if (dirty_page) {
			/* someone else touched the same data we're displaying */
			ajax_refresh_page();
		} else {
			ajax_hide();
			if (window.ajax_commit_pos) {
				ajax_commit_pos(rres);
			}
		}
	} else {
		for(var x = 0; x < inplace.length; ++x) {
			txt = escapeHTML(""+rres.row_formatted[inplace[x]]);
			idid = inplace[x]+"F"+rres.id;
			if (getElement(idid)) {
				swapDOM(idid, SPAN({"id": idid, "class": "ajaxupdated"}, txt));
			}
		}
		if (dirty_page) {
			/* someone else touched the same data we're displaying */
			ajax_refresh_page();
		} else {
			ajax_hide();
		}
		if (window.ajax_commit_pos) {
			ajax_commit_pos(rres); // called only if in-place-update has been done
		}
/*
	} else {
		// FIXME: deprecated
		if (_is_streamlined) {
			// back to insert a new record
			dirty_page = true;
			ajax_new();
		} else {
			// database changed, let's rebuild the table
			ajax_refresh_page();
		}
*/
	}
}

function ajax_remove_gotdata(rres)
{
	ajax_pending = false;
	ajax_throbber_end();

	if (is_defined(rres.err) && rres.err != "") {
		ajax_form_errmsg(rres.err);
		return;
	}

	if (is_defined(rres.msg) && rres.msg != "") {
		ajax_form_infomsg(rres.msg);
	}

	handle_version(rres.table_version, 2);

	if (getElement("tr"+document.f.id.value)) {
		removeElement("tr"+document.f.id.value);
		if (dirty_page) {
			/* someone else touched the same data we're displaying */
			ajax_refresh_page();
		} else {
			ajax_hide();
			if (window.ajax_remove_pos) {
				ajax_remove_pos(rres);
			}
		}
/*
	} else {
		// FIXME: deprecated
		ajax_refresh_page();
*/
	}
}

function ajax_edit_gotdata(rres)
{
	ajax_pending = false;
	ajax_throbber_end();

	if (is_defined(rres.err) && rres.err != "") {
		alert(fetch_remote_error+" ("+rres.err+")");
		return;
	}

	if (! is_defined(rres.id) || ! is_defined(rres.Legend) || ! is_defined(rres.table_version)) {
		alert(fetch_remote_error_bad+" (lacks ID, legend or version)");
		return;
	}

	for (var x = 0; x < controls.length; ++x) {
		if (! is_defined(rres[controls[x]])) {
			alert(fetch_remote_error_bad+" (lacks "+controls[x]+")");
			return;
		}
		field_setvalue(x, rres[controls[x]]);
	}

	handle_version(rres.table_version, 0);

	// workaround to a bug where the legend would not be updated unless there was an
	// alert() before this (probably some Firefox internal bug?)
	if (rres.id > 0) {
		callLater(0.1, update_legend, edit_legend + rres.Legend);
	} else {
		callLater(0.1, update_legend, new_row_legend);
	}

	if (window.ajax_edit_gotdata_extend) {
		ajax_edit_gotdata_extend(rres);
	}
}


function update_legend(msg)
{
	ajax_form_legend(msg);
}

function ajax_edit(id)
{
	if (ajax_pending) {
		return;
	}

	ajax_unhide();
	ajax_throbber();

	var jkeys = ["id"];
	var jvalues = [id];
	var addr = "fetch?" + queryString(jkeys, jvalues);
	var ajax = loadJSONDoc(addr);
	ajax.addCallbacks(ajax_edit_gotdata, ajax_error_hide);

	ajax_pending = true;

	_is_streamlined = streamlined_add && id <= 0;
}

function ajax_remove(event)
{
	if (parseInt(document.f.id.value) <= 0) {
		return;
	}

	if (ajax_pending) {
		return;
	}

	if (! confirm(remove_dialog)) {
		return;
	}

	ajax_throbber();

	var jkeys = ["id"];
	var jvalues = [document.f.id.value];
	var addr = "remove?" + queryString(jkeys, jvalues);
	var ajax = loadJSONDoc(addr);
	ajax.addCallbacks(ajax_remove_gotdata, ajax_error);

	ajax_pending = true;
}


function ajax_commit(event)
{
	if (ajax_pending) {
		return;
	}

	ajax_throbber();

	var jkeys = controls;
	var jvalues = [];
	for (var x = 0; x < controls.length; ++x) {
		jvalues.push(field_getvalue(x));
	}

	var addr = "update?" + queryString(jkeys, jvalues);
	var ajax = loadJSONDoc(addr);
	ajax.addCallbacks(ajax_commit_gotdata, ajax_error);

	ajax_pending = true;
}

function ajax_cancel(event)
{
	if (! ajax_pending) {
		if (dirty_page) {
			ajax_refresh_page();
		} else {
			ajax_hide();
		}
	}

}

function ajax_new(event)
{
	if (window.ajax_new_override) {
		ajax_new_override();
	} else {
		ajax_edit(-1);
	}
}

/*
function is_field(f)
{
	var tag = f.tagName ? f.tagName.toLowerCase() : "foo";
	var type = f.type ? f.type.toLowerCase() : "foo";

	return ((tag == "input") && highlight_fields[type]) || highlight_fields[tag];
}

function handleEnter(event) {
	var charCode = event.key()["code"];
	var target = event.target();
	var res = true;

	if (charCode == 13 || charCode == 3) {
		var i;
		for (i = 1; i < controls.length; i++) {
			if (target === fields[i]) {
				break;
			}
		}

		if (++i >= controls.length) {
			// wrap around field focus
			i = first_visible_field;
		}

		fields[i].focus();
		res = false;
	}
	return res;
}

function highlight(e)
{
	var target = e.target();
	if (previous_focus != null) {
		setElementClass(previous_focus, "");
	}
	if (is_field(target)) {
		setElementClass(target, "focus");
		previous_focus = target;
	}
}

*/
