<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns='http://www.w3.org/1999/xhtml' xmlns:py='http://purl.org/kid/ns#' py:extends="'master.kid'">
  <head>
    <title>Charts of accounts</title>
    <SCRIPT SRC='/static/javascript/charts.js' TYPE='text/javascript' defer='defer'/>
    <SCRIPT SRC='/static/javascript/tables.js' TYPE='text/javascript' defer='defer'/>
  </head>
  <body onLoad='ajax_setup()'>
    <h3>Charts of accounts</h3>
    <div class='hidden' id='formdiv'>
      <form onsubmit='return ajax_submit()' name='f' method='get'>
        <fieldset>
          <legend id='legend'/>
          <div>
            <div id='waiting' class='hidden'>
              <img src='/static/images/waiting.gif'/>
            </div>
            <div id='waitingpad' class='shown'/>
            <div id='errmsg'/>
            <div id='infomsg'/>
            <div class='clearer'/>
          </div>
          <table>
            <tr>
              <td>Description</td>
              <td>
                <input maxlength='40' type='text' name='description' value='' size='40'/>
              </td>
            </tr>
            <tr>
              <td>Format mask<br/>(without checkdigit)</td>
              <td>
                <input maxlength='20' type='text' name='mask' value='' size='20'/>
              </td>
            </tr>
            <tr id='copy' class='hidden'>
              <td>Copy accounts from chart:</td>
              <td>
                <select name='copyfrom' value='0'>
                  <option value='0'>(None)</option>
                  <option selected='${None}' py:for='ochart in rows' value='${ochart.id}'>
                    <span py:content='ochart.description'>Chart name</span>
                  </option>
                </select>
              </td>
            </tr>
          </table>
          <input type='hidden' name='id' value=''/>
          <input type='hidden' name='table_version' value='${table_version}'/>
          <button type='button' name='bsubmit' onClick='ajax_commit()'>Submit</button>
          <button type='button' name='bcancel' onClick='ajax_cancel()'>Cancel</button>
          <button type='button' name='bremove' onClick='ajax_remove()'>Remove</button>
        </fieldset>
      </form>
    </div>
    <div id='addrow' class='shown'>
      <a href='javascript:ajax_new()'>Add new chart</a>
    </div>
    <div class='tabledata' id='tabledata'>
      <table>
        <thead>
          <tr>
            <th>ID</th>
            <th>Description</th>
            <th>Format mask</th>
            <th/>
          </tr>
        </thead>
        <tbody>
          <tr class='newrow_invisible' id='newrow_invisible'>
            <td>
              <span id='idFNEW'/>
            </td>
            <td>
              <span id='descriptionFNEW'/>
            </td>
            <td>
              <span id='maskFNEW'/>
            </td>
            <td>
              <a href='javascript:ajax_edit(FNEWID)' class='edit'>Edit</a>
            </td>
          </tr>
          <tr py:for='i, row in enumerate(rows)' class="${i % 2 and 'odd' or 'even'}" id="${'tr'+str(row.id)}">
            <td>
              <span id="${'idF'+str(row.id)}" py:content='row.id'>ID</span>
            </td>
            <td>
              <span id="${'descriptionF'+str(row.id)}" py:content='row.description'>Description</span>
            </td>
            <td>
              <span id="${'maskF'+str(row.id)}" py:content='row.mask'>Name</span>
            </td>
            <td>
              <a href='javascript:ajax_edit(${row.id})' class='edit'>Edit</a>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <div/>
  </body>
</html>
