<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns='http://www.w3.org/1999/xhtml' xmlns:py='http://purl.org/kid/ns#' py:extends="'master.kid'">
  <head>
    <title>${title}</title>
    <SCRIPT SRC='/static/javascript/charts_accounts.js' TYPE='text/javascript' defer='defer'/>
    <SCRIPT SRC='/static/javascript/tables.js' TYPE='text/javascript' defer='defer'/>
    <SCRIPT SRC='/static/javascript/twolevel_tables.js' TYPE='text/javascript' defer='defer'/>
  </head>
  <body onLoad='ajax_setup()'>
    <h3>${title}</h3>
    <div class='hidden' id='formdiv'>
      <form onsubmit='return ajax_submit()' name='f' method='get'>
        <fieldset>
          <legend id='legend'/>
          <div>
            <div id='waiting' class='hidden'>
              <img src='/static/images/waiting.gif'/>
            </div>
            <div id='waitingpad' class='shown'/>
            <div id='errmsg'/>
            <div id='infomsg'/>
            <div class='clearer'/>
          </div>
          <table>
            <tr>
              <td>Class</td>
              <td>
                <select name='xclass'>
                  <option py:for='item in xclasses' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
			Automatic = copy class from parent
		</td>
            </tr>
            <tr>
              <td>Std. journal</td>
              <td>
                <input maxlength='6' type='text' name='stdjournal' value='' size='6'/>
		(1 = no default standard journal)
		</td>
            </tr>
            <tr>
              <td>Code</td>
              <td>
                <input maxlength='20' type='text' name='code' value='' size='20'/>
		  Mask: <span py:content='mask'>9.99.9999</span>
              </td>
            </tr>
            <tr>
              <td>Parent account</td>
              <td>
                <input maxlength='20' type='text' name='parent' value='' size='20'/>
		 (toplevels have no parent)
		</td>
            </tr>
            <tr>
              <td>Description</td>
              <td>
                <input maxlength='40' type='text' name='description' value='' size='40'/>
              </td>
            </tr>
            <tr>
              <td>Small description</td>
              <td>
                <input maxlength='20' type='text' name='smalldesc' value='' size='20'/>
		 (for mobile clients)
		</td>
            </tr>
            <tr>
              <td>Mobile clients</td>
              <td>
                <select name='mobile' value='0'>
                  <option py:for='item in mobiles' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
              </td>
            </tr>
            <tr>
              <td>Activity</td>
              <td>
                <select name='inactive' value='0'>
                  <option py:for='item in inactives' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
              </td>
            </tr>
          </table>
          <input type='hidden' name='id' value=''/>
          <input type='hidden' name='chart' value='${chart}'/>
          <input type='hidden' name='mask' value='${mask}'/>
          <input type='hidden' name='mask_separator' value='${mask_separator}'/>
          <input type='hidden' name='table_version' value='${table_version}'/>
          <button type='button' name='bsubmit' onClick='ajax_commit()'>Submit</button>
          <button type='button' name='bcancel' onClick='ajax_cancel()'>Cancel</button>
          <button type='button' name='bremove' onClick='ajax_remove()'>Remove</button>
        </fieldset>
      </form>
    </div>
    <div class='motherdata' id='motherdata'>
      <form name='motherselect' method='get'>
		Parent chart being edited: 
		<select name='mother' value='0'><option selected="${mother['id'] == chart and 'x' or None}" py:for='mother in mothers' value="${mother['id']}"><span py:content="mother['description']">Chart name</span>
          </option>
        </select>
      </form>
    </div>
    <div id='addrow' class='shown'>
      <a href='javascript:ajax_new()'>Add new account</a>
    </div>
    <div py:contents='softerr' class='errmsg2' py:if='softerr'>
    </div>
    <div class='tabledata' id='tabledata'>
      <table>
        <thead>
          <tr>
            <th>
              <a href='javascript:ajax_uncollapse_all()'>+</a>
            </th>
            <th>Code</th>
            <th>Description</th>
            <th/>
            <th/>
            <th/>
            <th/>
          </tr>
        </thead>
        <tbody>
          <tr class='newrow_invisible' id='newrow_invisible'>
            <td>
            </td>
            <td>
              <span id='codeFNEW'/>
            </td>
            <td>
              <span id='descriptionFNEW'/>
            </td>
            <td>
            </td>
            <td>
            </td>
            <td>
              <a href='javascript:ajax_edit_mother(${chart}, FNEWID)' class='edit'>Edit</a>
            </td>
            <td>
            </td>
          </tr>
          <tr code_class="${row['code_class']}" leaf="${row['leaf']}" py:for='i, row in enumerate(rows)' class="${row['css_class']} ${row['collapse_class']}" id="${'tr'+str(row['id'])}">
            <td class='collapse'>
              <a href="javascript:ajax_collapse('${'tr'+str(row['id'])}')" py:if="not row['leaf']">+
		</a>
            </td>
            <td>
              <span id="${'codeF'+str(row['id'])}" py:content="row['code']">X</span>
            </td>
            <td>
              <span id="${'descriptionF'+str(row['id'])}" py:content="row['description']">X</span>
            </td>
            <td>
              <a href='javascript:ajax_mobile(${chart}, ${row["id"]})' py:if="not row['aggregate']">
                <span id="${'mob'+str(row['id'])}" class="${row['mobile'] and 'on' or 'off'}">Mobile</span>
              </a>
            </td>
            <td>
              <a href='javascript:ajax_inactive(${chart}, ${row["id"]})' py:if="not row['aggregate']">
                <span id="${'ina'+str(row['id'])}" class="${row['inactive'] and 'on' or 'off'}">Inactive</span>
              </a>
            </td>
            <td>
              <a href='javascript:ajax_edit_mother(${chart}, ${row["id"]})' class='edit'>Edit</a>
            </td>
            <td>
              <span py:content="row['err']">X</span>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <div/>
  </body>
</html>
