<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns='http://www.w3.org/1999/xhtml' xmlns:py='http://purl.org/kid/ns#' py:extends="'master.kid'">
  <head>
    <title>${title}</title>
    <SCRIPT SRC='/static/javascript/journals.js' TYPE='text/javascript' defer='defer'/>
    <SCRIPT SRC='/static/javascript/tables.js' TYPE='text/javascript' defer='defer'/>
  </head>
  <body onLoad='ajax_setup()'>
    <h3>${title}</h3>
    <div class='hidden' id='formdiv'>
      <form onsubmit='return ajax_submit()' name='f' method='get'>
        <fieldset>
          <legend id='legend'/>
          <div>
            <div id='waiting' class='hidden'>
              <img src='/static/images/waiting.gif'/>
            </div>
            <div id='waitingpad' class='shown'/>
            <div id='errmsg'/>
            <div id='infomsg'/>
            <div class='clearer'/>
          </div>
          <table>
            <tr>
              <td>DB account</td>
              <td>
                <select name='accountDB' id='accountDB'>
                </select>
                <input maxlength='40' name='accountDB_filter' value='' size='20'/>
              </td>
            </tr>
            <tr>
              <td>CR account</td>
              <td>
                <select name='accountCR' id='accountCR'>
                </select>
                <input maxlength='40' name='accountCR_filter' value='' size='20'/>
              </td>
            </tr>
            <tr>
              <td>Std. journal</td>
              <td>
                <input maxlength='6' type='text' name='stdjournal' value='' size='6'/>
		(1 = none)
		</td>
            </tr>
            <tr>
              <td>Cost center</td>
              <td>
                <input maxlength='6' type='text' name='costcenter' value='' size='6'/>
		(1 = none)
		</td>
            </tr>
            <tr>
              <td>Date</td>
              <td>
                <input maxlength='12' type='text' name='day' value='' size='12'/>
              </td>
            </tr>
            <tr>
              <td>Description</td>
              <td>
                <input maxlength='60' type='text' name='description' value='' size='60'/>
              </td>
            </tr>
            <tr>
              <td class='numeric'>Value</td>
              <td>
                <input maxlength='20' type='text' name='value' value='' size='20'/>
		(without decimal point/comma)
		</td>
            </tr>
            <tr>
              <td>Status</td>
              <td>
                <select name='cancelled' value='0'>
                  <option py:for='item in cancelledlist' value="${item['id']}">
                    <span py:content="item['description']"/>
                  </option>
                </select>
              </td>
            </tr>
          </table>
          <input type='hidden' name='id' value=''/>
          <input type='hidden' name='table_version' value='${table_version}'/>
          <input type='hidden' name='org' value='${org}'/>
          <input type='hidden' name='batch' value='${batch}'/>
          <button type='button' name='bsubmit' onClick='ajax_commit()'>Submit</button>
          <button type='button' name='bcancel' onClick='ajax_cancel()'>Cancel</button>
        </fieldset>
      </form>
    </div>
    <div class='grandmotherdata' id='grandmotherdata'>
      <form name='grandmotherselect' method='get'>
      </form>
    </div>
    <div class='motherdata' id='motherdata'>
      <form name='motherselect' method='get'>
        <table>
          <tr>
            <td>
		Organization: 
		</td>
            <td>
              <select name='grandmother' value='0'>
                <option selected="${grandmother['id'] == org and 'x' or None}" py:for='grandmother in grandmothers' value="${grandmother['id']}">
                  <span py:content="grandmother['description']">Organization name</span>
                </option>
              </select>
            </td>
          </tr>
          <tr>
            <td>
		Batch:
		</td>
            <td>
              <select name='mother' value='0'>
                <option selected="${mother['id'] == batch and 'x' or None}" py:for='mother in mothers' value="${mother['id']}">
                  <span py:content="mother['description']">Batch name</span>
                </option>
              </select>
            </td>
          </tr>
        </table>
      </form>
      <div py:if='org > 0 and batch > 0 and not batch_open' class='journal_reopenbatch'>
	Batch is closed. <a href='reopen_batch?mother=${batch}&amp;grandmother=${org}'>Reopen batch</a>
      </div>
    </div>
    <div id='addrow' class='shown'>
      <a href='javascript:ajax_new()'>Add new journal</a>
    </div>
    <div py:contents='softerr' class='errmsg2' py:if='softerr'>
    </div>
    <div class='tabledata' id='tabledata'>
      <table>
        <thead>
          <tr>
            <th>
              <a href='javascript:ajax_uncollapse_all()'>+</a>
            </th>
            <th/>
            <th>Date</th>
            <th>Account</th>
            <th>Description/CC</th>
            <th class='number'>DB</th>
            <th class='number'>CR</th>
            <th>Status</th>
            <th/>
          </tr>
        </thead>
        <tbody>
          <tr class='newrow_invisible' id='newrow_invisible'>
            <td class='journalcode'>
              <span id='idFNEW'/>
            </td>
            <td/>
            <td>
              <span id='dayFNEW'/>
            </td>
            <td>
              <span id='account_fullFNEW'/>
            </td>
            <td>
              <span id='description_fullFNEW'/>
              <span id='costcenter_full2FNEW'/>
            </td>
            <td class='number'>
              <span id='value_dbFNEW'/>
            </td>
            <td class='number'>
              <span id='value_crFNEW'/>
            </td>
            <td>
              <a href='javascript:ajax_cancelled(${org}, ${batch}, FNEWID)'>
                <span id='cancelledFNEW'/>
              </a>
            </td>
            <td>
              <a href='javascript:ajax_edit_grandmother(${org}, ${batch}, FNEWID)' class='edit'>Edit</a>
            </td>
          </tr>
          <tr code_class="${row['code_class']}" py:for='i, row in enumerate(rows)' class="${row['unbalanced'] and 'unbalanced' or (i % 2 and 'odd' or 'even')} ${row['collapse_class']}" id="${'tr'+str(row['id'])}">
            <td class='collapse'>
              <a href="javascript:ajax_collapse('${'tr'+str(row['id'])}')" py:if="row['day_dtoc']">+</a>
            </td>
            <td class='journalcode'>
              <span id="${'idF'+str(row['id'])}" py:content="row['id']">X</span>
            </td>
            <td>
              <span id="${'dayF'+str(row['id'])}" py:content="row['day_dtoc']">X</span>
            </td>
            <td>
              <span id="${'account_fullF'+str(row['id'])}" py:content="row['account_full']">X</span>
            </td>
            <td>
              <span id="${'description_fullF'+str(row['id'])}" py:content="row['description_full']">X</span>
            </td>
            <td class='number'>
              <span id="${'value_dbF'+str(row['id'])}" py:content="row['value_db']">X</span>
            </td>
            <td class='number'>
              <span id="${'value_crF'+str(row['id'])}" py:content="row['value_cr']">X</span>
            </td>
            <td>
              <a href='javascript:ajax_cancelled(${org}, ${batch}, ${row["id"]})'>
                <span id="${'cancelledF'+str(row['id'])}" py:content="row['cancelled'] and 'Cancelled' or 'Ok'"/>
              </a>
            </td>
            <td>
              <a href='javascript:ajax_edit_grandmother(${org}, ${batch}, ${row["id"]})' class='edit' py:if='batch_open'>Edit</a>
            </td>
          </tr>
        </tbody>
        <tfoot>
          <tr class='checktotal' py:if='mother and grandmother'>
            <td/>
            <td/>
            <td/>
            <td>
              <span>Checksum</span>
            </td>
            <td/>
            <td>
              <span id='total_db' py:content='total_db'>X</span>
            </td>
            <td>
              <span id='total_cr' py:content='total_cr'>X</span>
            </td>
            <td/>
            <td/>
          </tr>
        </tfoot>
      </table>
    </div>
    <div/>
  </body>
</html>
