<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns='http://www.w3.org/1999/xhtml' xmlns:py='http://purl.org/kid/ns#' py:extends="'master.kid'">
  <head>
    <title>Account classes</title>
    <SCRIPT SRC='/static/javascript/sys_classes.js' TYPE='text/javascript' defer='defer'/>
    <SCRIPT SRC='/static/javascript/tables.js' TYPE='text/javascript' defer='defer'/>
  </head>
  <body onLoad='ajax_setup()'>
    <h3>Account Classes</h3>
    <div class='hidden' id='formdiv'>
      <form onsubmit='return ajax_submit()' name='f' method='get'>
        <fieldset>
          <legend id='legend'/>
          <div>
            <div id='waiting' class='hidden'>
              <img src='/static/images/waiting.gif'/>
            </div>
            <div id='waitingpad' class='shown'/>
            <div id='errmsg'/>
            <div id='infomsg'/>
            <div class='clearer'/>
          </div>
          <table>
            <tr>
              <td>Order number</td>
              <td>
                <input maxlength='4' type='text' name='oid' value='' size='4'/>
              </td>
            </tr>
            <tr>
              <td>Description</td>
              <td>
                <input maxlength='20' type='text' name='description' value='' size='20'/>
              </td>
            </tr>
            <tr>
              <td>Superclass</td>
              <td>
                <select name='is_income' value='0'>
                  <option value='0'>Assets/Liabilities/Equity</option>
                  <option value='1'>Income (Revenue/Expense)</option>
                </select>
              </td>
            </tr>
            <tr>
              <td>Normal balance</td>
              <td>
                <select name='normal_balance' value='0'>
                  <option value='0'>Credit</option>
                  <option value='1'>Debit</option>
                </select>
              </td>
            </tr>
          </table>
          <input type='hidden' name='id' value=''/>
          <input type='hidden' name='table_version' value='${table_version}'/>
          <button type='button' name='bsubmit' onClick='ajax_commit()'>Submit</button>
          <button type='button' name='bcancel' onClick='ajax_cancel()'>Cancel</button>
          <button type='button' name='bremove' onClick='ajax_remove()'>Remove</button>
        </fieldset>
      </form>
    </div>
    <div id='addrow' class='shown'>
      <a href='javascript:ajax_new()'>Add new account class</a>
    </div>
    <div class='tabledata' id='tabledata'>
      <table>
        <thead>
          <tr>
            <th>Order number</th>
            <th>Description</th>
            <th>Superclass</th>
            <th>Normal balance</th>
            <th/>
          </tr>
        </thead>
        <tbody>
          <tr class='newrow_invisible' id='newrow_invisible'>
            <td>
              <span id='oidFNEW'/>
            </td>
            <td>
              <span id='descriptionFNEW'/>
            </td>
            <td>
              <span id='is_incomeFNEW'/>
            </td>
            <td>
              <span id='normal_balanceFNEW'/>
            </td>
            <td>
              <a href='javascript:ajax_edit(FNEWID)' class='edit'>Edit</a>
            </td>
          </tr>
          <tr py:for='i, row in enumerate(rows)' class="${i % 2 and 'odd' or 'even'}" id="${'tr'+str(row.id)}">
            <td>
              <span id="${'oidF'+str(row.id)}" py:content='row.oid'>OID</span>
            </td>
            <td>
              <span id="${'descriptionF'+str(row.id)}" py:content='row.description'>Description</span>
            </td>
            <td>
              <span id="${'is_incomeF'+str(row.id)}" py:content="row.is_income and 'Income (Revenue/Expense)' or 'Assets/Liabilities/Equity'">Incoming/expense</span>
            </td>
            <td>
              <span id="${'normal_balanceF'+str(row.id)}" py:content="row.normal_balance and 'Debit' or 'Credit'">Normal balance</span>
            </td>
            <td>
              <a href='javascript:ajax_edit(${row.id})' class='edit'>Edit</a>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <div/>
  </body>
</html>
