# -*- coding: UTF-8 -*-

# If your project uses a database, you can set up database tests
# similar to what you see below. Be sure to set the db_uri to
# an appropriate uri for your testing database. sqlite is a good
# choice for testing, because you can use an in-memory database
# which is very fast.

from turbogears import database as db
from turbogears.util import get_model

from turbogears import testutil

class TestCurrency(object):
    model = None

    def setUp(self):
        if not self.model:
            self.model = get_model()
            if not self.model:
                raise "Unable to run database tests without a model"

        db.set_db_uri("sqlite:///:memory:")

        self.model.touch()

    def test_create(self):
        "Object creation should set the name and code"

        obj = self.model.Currency(name=u'Japanese yen', code=u'JPY')
        assert obj.name == u'Japanese yen'
        assert obj.code == u'JPY'
        assert obj.autoDownload == 1
