#!/usr/bin/env python2.5

# Copyright (c) 2005 INdT - Instituto Nokia de Tecnologia, Elvis Pfutzenreuter.
# All rights reserved. This software is released under the LGPL licence.

is_hildon = 1

try:
	import hildon
	import osso
except:
	is_hildon = 0

import face_hildon

import protocol
import client_database
import bluetooth_linux
import anydbm
import time
from mylib import CommError, DatamodelError
import socket
import random
import random
import os

home = os.getenv("HOME", default="/home/user")+"/lucamobile/"
if not os.path.isdir(home):
        os.mkdir(home)

repo_journal = client_database.journal(anydbm, home+"journal.dbm")
repo_stdjournals = client_database.stdjournals(anydbm, home+"stdjournals.dbm")
repo_accounts = client_database.accounts(anydbm, home+"accounts.dbm")
repo_cmos = client_database.cmos(anydbm, home+"cmos.dbm")

protocol.register_net_exceptions(bluetooth_linux.exceptions)

def init():
	repo_journal.truncate()
	repo_stdjournals.truncate()
	repo_accounts.truncate()
	repo_cmos.truncate()

def sync(request, host):
	if request == 0:
		return bluetooth_linux.device_list()

	origret = ret = "Sync was successful."

	try:
		sock = bluetooth_linux.client_socket(host)
		c = protocol.client(sock, repo_cmos, repo_stdjournals, repo_accounts, repo_journal)
		work = 2
		while c.active:
			if work <= 0:
				raise Exception("No usable work done in 2 loops!")
			work = work - 1
	
			if c.tick():
				# print "Tick."
				work = 2
				# Client may have deactivated in this point
				continue

			rdneeded, wrneeded = c.sock_needs()
			rd, wr = protocol.wait_one(rdneeded, wrneeded)
				
			if rd:
				c.tick_read()
				work = 2
			if wr:
				c.tick_write()
				work = 2

	except (CommError, DatamodelError), e:
		ret = unicode(e)

	return ret


def syncweb(request, url):
	if request == 0:
		# just needs the default URL
		return protocol.clientweb_default_url(repo_cmos)
	
	origret = ret = "Sync was successful."

	try:
		c = protocol.clientweb(url, repo_cmos, repo_stdjournals, repo_accounts, repo_journal)
		work = 2
		while c.active:
			if work <= 0:
				raise Exception("No usable work done in 2 loops!")
			work = work - 1
	
			if c.tick():
				# print "Tick."
				work = 2
				# Client may have deactivated in this point
				continue

			if c.send_buffer:
				c.tick_write() # does the Web request
				c.tick_read()
				work = 2

		# Good URl; Save URL for future reference
		protocol.clientweb_set_default_url(repo_cmos, url)

	except (CommError, DatamodelError), e:
		ret = unicode(e)

	return ret

if is_hildon:
	o = osso.Context("lucamobile", "1.0.0", False)

f = face_hildon.face_hildon(repo_journal, repo_accounts, sync, syncweb, init)

f.main()

if is_hildon:
	o.close()

